<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<!--       
 *     Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved.
 *     Use is subject to license terms.
 *
-->
<html>
    <head><meta http-equiv="content-type" content="text/html; charset=UTF-8">
        <title>About JavaScript Code Completion</title>
        <link rel="StyleSheet" href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/ide.css" type="text/css">
        
    </head>
    <body>
        <h2>About JavaScript Code Completion and Type Analysis</h2>
        <p><small><a href="#seealso">See Also</a></small></p>
        
        <p>JavaScript code completion gives you a choice of the IDE's built-in JavaScript core classes to insert into your code. For example, you can write</p>
        <pre>    x = "foo";      y = x;      y.  </pre>
        <p>and code completion will show you the methods available for JavaScript  strings. Code completion works with all the literal types in JavaScript. The type  analysis and  code completion machinery also knows about prototype style classes  (regular functions only) and the new operator for constructing  them.</p>
        <p> NetBeans IDE consults type parameters for function parameters and return types  (@type, @param). These types are shown in code completion: in the list,  in the   documentation, and in parameter hints (Ctrl-P). Return types   are also shown in the code completion dialog after the function name,   separated by a colon. </p>
        <p> If you mark a method with <tt>@deprecated</tt>, it is struck through in the navigator   and in code completion calls to this method. The accompanying deprecated description is shown in a separate section in the code   completion documentation with a highlighted background.
        
        <p> NetBeans IDE can also determine the return type for many functions. This function is essential for JQuery support. </p> 
        
        <h3>Documentation</h3>
        <p>Code completion shows the API documentation for both the core javascript APIs and the DOM APIs.  You can also view documentation for your own functions. Ctrl-pointing at calls also shows  documentation (as a tooltip). 
        </p>
        
        <h3>Embedded Completion</h3> 
        <p>Code completion on element IDs in the  HTML works for the <tt>Prototype.js $(&quot;...&quot;)</tt> function. To see code completion on element IDs, press Ctrl-Space within the quotation marks. For example, if you add <em>variable </em> = $("f<strong>|</strong>") and press Ctrl-Space with the cursor (<strong>|) </strong>immediately after the f, code completion shows all HTML element IDs in the document that start with f. </p>
        
        <h3>JSDoc Support</h3>
        <p>If you annotate a method with <tt>@private</tt>, it shows up in the navigator with a lock icon. 
            If you annotate a function with <tt>@constructor</tt> it is shown as a  constructor 
            (and included in code completion after the "new" keyword),  and you can use <tt>@class</tt> 
            and <tt>@namespace</tt> to explicitly assign functions  to given classes 
            (though the type analyzer can often assign these functions automatically).  
            Functions marked <tt>@ignore</tt> do not show up in code completion. However, 
        such functions are included in the index and can be used in a Go To Declaration. </p>
        
        <h3>Basic File Inclusion Filtering</h3> 
        <p>Code completion in HTML only includes code from referenced JavaScript files. Consider a project in which the file <tt>foo.js</tt>  defines the function <tt>foo()</tt>, and the file <tt>bar.js</tt> defines the function <tt>bar()</tt>. If  the file <tt>hello.html</tt>  includes only <tt>&lt;script src="bar.js"&gt;&lt;/script&gt;</tt>,  only the <tt>bar()</tt> function is shown in code completion for <tt>hello.html</tt>. 
        </p> 
        
        <ul class="note">
            <li>For an illustrated description of JavaScript editing features in the NetBeans IDE,
                see the following web document:
                <p><object classid="java:org.netbeans.modules.javahelp.BrowserDisplayer">
                    <param name="content" value="http://www.netbeans.org/kb/docs/ide/javascript-editor.html">
                    <param name="text" value="<html><u>Editing JavaScript (Web document)</u></html>">
                    <param name="textFontSize" value="medium">
                    <param name="textColor" value="blue">
                </object>
            </li>
        </ul>
        <dl>
            <dt><a name="seealso">See Also</a></dt>
            <dd><a href="js_basics.html">Basic JavaScript Editing Features</a></dd>
        </dl>
        <hr>
        <small><a href="../credits.html">Legal Notices</a></small>
        <table border="0" cellpadding="50">
        <tr><td>&nbsp;</td></tr>
    </table>
    </body>
</html>
